SystemOrganization addCategory: #'Pier-Tests-Book'!

TestCase subclass: #BOEPUBViewTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Book'!

!BOEPUBViewTest methodsFor: 'book - structures' stamp: 'YanniChiu 8/4/2012 01:11'!
bookForFigureTest
	| root book part chapter section figure |
	root := (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (book := BOBook named: 'book');
		yourself.

	book addChild: (part := (BOPortion named: 'part-1') type: #part).
	part addChild: (chapter := (BOPortion named: 'chapter-1-1') contents: 'ch-1-1').
	chapter addChild: (section := (BOPortion named: 'section-1-1-1') contents: '+fig-1+').
	section addChild: (figure := (BOFigure named: 'fig-1')).
	figure file: (MAExternalFileModel new filename: 'figure1.xyz'; contents: 'xyz' asByteArray; yourself).

	^ root! !

!BOEPUBViewTest methodsFor: 'book - structures' stamp: 'YanniChiu 3/26/2012 10:56'!
bookForTableOfContentsTest
	| root book part chapter section |
	root := (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (book := BOBook named: 'book');
		yourself.

	book addChild: (part := (BOPortion named: 'part-1') type: #part; yourself).
	part addChild: (chapter := BOPortion named: 'chapter-1').
	chapter addChild: (section := BOPortion named: 'section-1-1').
	section addChild: (BOPortion named: 'subsection-1-1-1').
	section addChild: (BOPortion named: 'subsection-1-1-2').
	chapter addChild: (section := BOPortion named: 'section-1-2').
	section addChild: (BOPortion named: 'subsection-1-2-1').
	section addChild: (BOPortion named: 'subsection-1-2-2').
	part addChild: (chapter := BOPortion named: 'chapter-2').
	chapter addChild: (BOPortion named: 'section-2-1').
	chapter addChild: (BOPortion named: 'section-2-2').

	book addChild: (part := (BOPortion named: 'part-2') type: #part; yourself).
	part addChild: (chapter := BOPortion named: 'chapter-3').
	chapter addChild: (BOPortion named: 'section-3-1').
	chapter addChild: (BOPortion named: 'section-3-2').
	part addChild: (chapter := BOPortion named: 'chapter-4').
	chapter addChild: (BOPortion named: 'section-4-1').
	chapter addChild: (BOPortion named: 'section-4-2').

	^ root! !

!BOEPUBViewTest methodsFor: 'book - structures' stamp: 'YanniChiu 8/1/2012 12:34'!
bookForZipMemberTest
	| root book part chapter section subsection |
	root := (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (book := BOBook named: 'book');
		yourself.

	book addChild: (part := (BOPortion named: 'part-1') type: #part).
	part addChild: (chapter := (BOPortion named: 'chapter-1-1') contents: 'ch-1-1').
	chapter addChild: (section := (BOPortion named: 'section-1-1-1') contents: 'sec-1-1-1').
	section addChild: (subsection := (BOPortion named: 'subsection') contents: 'subsec').

	book addChild: (part := (BOPortion named: 'part-2') type: #part).
	part addChild: (chapter := (BOPortion named: 'chapter-2-1') contents: 'ch-2-1').
	chapter addChild: (section := (BOPortion named: 'section-2-1-1') contents: 'sec-2-1-1').
	chapter addChild: (section := (BOPortion named: 'section-2-1-2') contents: 'sec-2-1-2').
	part addChild: (chapter := (BOPortion named: 'chapter-2-2') contents: 'ch-2-2').
	chapter addChild: (section := (BOPortion named: 'section-2-2-1') contents: 'sec-2-2-1').
	chapter addChild: (section := (BOPortion named: 'section-2-2-2') contents: 'sec-2-2-2').

	^ root! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 8/1/2012 13:05'!
bookWithPierWikiContent
	"Answer a Pier book using all the various Pier wiki syntax features"
	| root book part chapter |
	root := (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (book := BOBook named: 'book');
		yourself.
	book addChild: (part := (BOPortion named: 'part') type: #part; yourself).
	part addChild: (part := (BOPortion named: 'chapter') type: #chapter; yourself).
	part
		addChild: self exampleParagraphs;
		addChild: self exampleAnnotations;
		addChild: self exampleSections;
		addChild: self exampleLists;
		addChild: self exampleTables;
		addChild: self examplePreformatted;
		addChild: self exampleFormatting;
		addChild: self exampleVerbatim;
		addChild: self exampleLinks;
		addChild: self exampleValues;
		yourself.
	^ root! !

!BOEPUBViewTest methodsFor: 'book - structures' stamp: 'YanniChiu 3/26/2012 01:16'!
bookWithSubsubsubsections
	"Answer a Pier book using various nested structures"
	| root book part chapter section subsection subsubsection subsubsubsection |
	root := (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (book := BOBook named: 'book');
		yourself.
	book addChild: (part := BOPortion named: 'part-1').
	part type: #part.
	part addChild: (chapter := BOPortion named: 'chapter-1').
	chapter contents: 'ch1'.
	chapter addChild: (section := BOPortion named: 'section-1-1').
	section contents: 'sec-1-1'.
	section addChild: (subsection := BOPortion named: 'subsection').
	subsection contents: 'subsec'.
	subsection addChild: (subsubsection := BOPortion named: 'subsubsection').
	subsubsection contents: 'subsubsec'.
	subsubsection addChild: (subsubsubsection := BOPortion named: 'subsubsection').
	subsubsubsection contents: 'subsubsubsec'.
	^ root! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/25/2012 22:48'!
contentsOfStructure: structure
	| stream |
	BOEPUBView new writeStructure: structure on: (stream := ReadWriteStream on: String new).
	^ stream contents! !

!BOEPUBViewTest methodsFor: 'book - empty' stamp: 'YanniChiu 3/26/2012 09:52'!
emptyBook
	| root book chapter |
	root := (PRPage named: 'root')
		title: 'Root';
		contents: 'Root stuff';
		addChild: (book := BOBook named: 'book');
		yourself.
	book addChild: (chapter := BOPortion named: 'chapter').
	^ root! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 22:40'!
exampleAnnotations
	^ ((BOPortion named: 'annotations')
		contents:
'@@todo todo annotation';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 23:05'!
exampleFormatting
	^ ((BOPortion named: 'formatting')
		contents:
'""Formatting""
""bold"" ''italic'' ==monospaced== --strikethrough-- @@subscripted@@ ^^superscripted^^ __underlined__';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/26/2012 00:31'!
exampleLinks
	^ ((BOPortion named: 'links')
		contents:
'""Links""
-*Root>/*
-*Non-existing internal page link>/nonexisting*
-*http://www.foobar.com*
-*Aliased external link>http://www.foobar.com*';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 21:53'!
exampleLists
	^ ((BOPortion named: 'lists')
		contents:
'""Numbered List""
#item1
#item2
#item3
""Bulleted List""
-item1
-item2
-item3
""Definition List""
;a
:b
:c
;x
:y
:z';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 22:40'!
exampleParagraphs
	^ ((BOPortion named: 'paragraphs')
		contents:
'Lorem ipsum';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 23:00'!
examplePreformatted
	^ ((BOPortion named: 'preformatted')
		contents:
'""Preformatted""
=main() { exit(0); }';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 22:41'!
exampleSections
	^ ((BOPortion named: 'sections')
		contents:
'!!Level1
!!!!Level2
!!!!!!Level3
!!!!!!!!Level4
!!!!!!!!!!Level5
!!!!!!!!!!!!Level6';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/25/2012 22:55'!
exampleTables
	^ ((BOPortion named: 'tables')
		contents:
'""regular table""
|a|b|c
|x|y|z
""left justified table""
|{asdf|{jklh
|{a|{b
|{xy|{yz;
""right justified table""
|}asdf|}jklh
|}a|}b
|}xy|}yz
""centre justified table""
||asdf||jklh
||a||b
||xy||yz
""table headings""
|!!heading1|!!heading2
|value11|value12
|value21|value22';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/26/2012 00:26'!
exampleValues
	^ ((BOPortion named: 'values')
		contents:
'""Values""
-date: +value:date+
-time: +value:time+
-owner: +value:owner+
-group: +value:group+
-source: +value:source+
-user: +value:user+
-kernel: +value:kernel+';
		yourself)! !

!BOEPUBViewTest methodsFor: 'book - wiki content' stamp: 'YanniChiu 3/26/2012 00:04'!
exampleVerbatim
	^ ((BOPortion named: 'verbatim')
		contents:
'{{{<a href="http://www.foobar.com">verbatim foobar.com link</a>}}}
_
{{{<foobar>}}}invalid tag surrounds this text (verbatim){{{</foobar>}}}
_';
		yourself)! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 8/4/2012 01:43'!
testFigure
	<expectedFailure>
	"Don't know how to make this test pass. It fails because
	PREmbeddedRenderer uses PRCurrentContext, which is not easily set up for testing.
	
	The test also leaves a tmp file on the file system."

	| root book figure epubview zip response figureMember |

	root := self bookForFigureTest.
	book := root lookupPath: 'book'.
	figure := book lookupPath: 'part-1/chapter-1-1/section-1-1-1/fig-1'.
	epubview := BOEPUBView on: (PRContext new setStructure: book).
	response := BOEPUBMockResponse new.
	epubview respondUsing: response.
	zip := ZipArchive new.
	zip readFrom: response stream.

	self assert: (zip memberNamed: 'OEBPS/book.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/part-1.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/chapter-1-1.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/section-1-1-1.html') isNil.

	figureMember := zip memberNamed: 'OEBPS/', figure file relativePathName.
	self assert: figureMember notNil.
	"figureMember contents returns a String, so must compare with a String below"
	self assert: 'xyz' equals: figureMember contents.

	self assert: 'todo' equals: (self contentsOfStructure: (book lookupPath: 'part-1/chapter-1-1')) contents.
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/26/2012 10:25'!
testMetadata
	"Use a book that's essentially empty of content, to test the metadata and boilerplate XML"
	| root book epubview zip response |

	root := self emptyBook.
	book := root lookupPath: 'book'.
	epubview := BOEPUBView on: (PRContext new setStructure: book).
	response := BOEPUBMockResponse new.
	epubview respondUsing: response.
	zip := ZipArchive new.
	zip readFrom: response stream.

	self assert: (zip memberNamed: 'mimetype') notNil.
	self assert: (zip memberNamed: 'META-INF/container.xml') notNil.
	self assert: (zip memberNamed: 'OEBPS/content.opf') notNil.
	self assert: (zip memberNamed: 'OEBPS/toc.ncx') notNil.
	self assert: (zip memberNamed: 'OEBPS/book.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/chapter.html') notNil.

	self assert: (zip memberNamed: 'mimetype') contents = 'application/epub+zip'.

	self assert: (zip memberNamed: 'META-INF/container.xml') contents withUnixLineEndings
		= '<?xml version="1.0" encoding="utf-8" standalone="no"?>
<container xmlns="urn:oasis:names:tc:opendocument:xmlns:container" version="1.0"><rootfiles><rootfile full-path="OEBPS/content.opf" media-type="application/oebps-package+xml"/></rootfiles></container>' withUnixLineEndings.

	self assert: (zip memberNamed: 'OEBPS/content.opf') contents withUnixLineEndings
		= '<?xml version="1.0" encoding="utf-8" standalone="no"?>
<package xmlns="http://www.idpf.org/2007/opf" version="2.0" unique-identifier="book">
  <metadata>
    <dc:identifier xmlns:dc="http://purl.org/dc/elements/1.1/" id="book">_idbook</dc:identifier>
    <dc:title xmlns:dc="http://purl.org/dc/elements/1.1/">Book</dc:title>
    <dc:creator xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:opf="http://www.idpf.org/2007/opf" opf:file-as="nil">nil</dc:creator>
    <dc:language xmlns:dc="http://purl.org/dc/elements/1.1/">en</dc:language>
  </metadata>
  <manifest>
    <item id="ncxtoc" href="toc.ncx" media-type="application/x-dtbncx+xml"/>
<item id="id3" href="chapter.html" media-type="application/xhtml+xml"/>
  </manifest>
  <spine toc="ncxtoc">
<itemref idref="id3"/>
  </spine>
</package>' withUnixLineEndings.

	self assert: (zip memberNamed: 'OEBPS/toc.ncx') contents withUnixLineEndings
		= '<?xml version="1.0" encoding="utf-8" standalone="no"?>
<ncx xmlns="http://www.daisy.org/z3986/2005/ncx/" version="2005-1">
  <head>
    <meta name="dtb:uid" content="_idbook"/>
  </head>
  <docTitle>
    <text>Book</text>
  </docTitle>
  <navMap>
<navPoint id="id2" playOrder="2">
  <navLabel><text>Book</text></navLabel>
  <content src="book.html"/>
<navPoint id="id3" playOrder="3">
  <navLabel><text>Chapter</text></navLabel>
  <content src="chapter.html"/>
</navPoint>
</navPoint>
  </navMap>
</ncx>' withUnixLineEndings.

	self assert: (zip memberNamed: 'OEBPS/book.html') contents withUnixLineEndings
		= '<!!DOCTYPE html><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Book</title>
    <link rel="stylesheet" type="text/css" href="ebook.css"/>
    <meta name="generator" content="Pier Book"/>
  </head>
  <body>
          <div>
            <h1 class="title"><a id="id2"/>Book</h1>
          </div>
          <div>
          </div>
        <hr/>
  </body>
</html>' withUnixLineEndings.

	self assert: (zip memberNamed: 'OEBPS/chapter.html') contents withUnixLineEndings
		= '<!!DOCTYPE html><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Chapter</title>
    <link rel="stylesheet" type="text/css" href="ebook.css"/>
    <meta name="generator" content="Pier Book"/>
  </head>
  <body>
          <div>
            <h1 class="title"><a id="id3"/>Chapter</h1>
          </div>
          <div>
          </div>
        <hr/>
  </body>
</html>' withUnixLineEndings.
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 8/2/2012 11:42'!
testPierWikiContent
	| root structure epubview stream |

	root := self bookWithPierWikiContent.

	self assert:
		'<a id="paragraphs"></a><h3>Paragraphs</h3><p>Lorem ipsum</p>'
		equals: (self contentsOfStructure: (root lookupPath: 'book/part/chapter/paragraphs')).

	self assert:
		'<a id="annotations"></a><h3>Annotations</h3><p class="annotated todo">todo annotation</p>'
		equals: (self contentsOfStructure: (root lookupPath: 'book/part/chapter/annotations')).

	self assert:
		'<a id="sections"></a><h3>Sections</h3><h1>Level1</h1><h2>Level2</h2><h3>Level3</h3><h4>Level4</h4><h5>Level5</h5><h6>Level6</h6>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/sections')).

	self assert:
		'<a id="lists"></a><h3>Lists</h3><p><strong>Numbered List</strong></p><ol><li>item1</li><li>item2</li><li>item3</li></ol><p><strong>Bulleted List</strong></p><ul><li>item1</li><li>item2</li><li>item3</li></ul><p><strong>Definition List</strong></p><dl><dt>a</dt><dd>b</dd><dd>c</dd><dt>x</dt><dd>y</dd><dd>z</dd></dl>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/lists')).

	self assert:
		'<a id="tables"></a><h3>Tables</h3><p><strong>regular table</strong></p><table><tr><td>a</td><td>b</td><td>c</td></tr><tr><td>x</td><td>y</td><td>z</td></tr></table><p><strong>left justified table</strong></p><table><tr><td style="text-align: left">asdf</td><td style="text-align: left">jklh</td></tr><tr><td style="text-align: left">a</td><td style="text-align: left">b</td></tr><tr><td style="text-align: left">xy</td><td style="text-align: left">yz;</td></tr></table><p><strong>right justified table</strong></p><table><tr><td style="text-align: right">asdf</td><td style="text-align: right">jklh</td></tr><tr><td style="text-align: right">a</td><td style="text-align: right">b</td></tr><tr><td style="text-align: right">xy</td><td style="text-align: right">yz</td></tr></table><p><strong>centre justified table</strong></p><table><tr><td style="text-align: center">asdf</td><td style="text-align: center">jklh</td></tr><tr><td style="text-align: center">a</td><td style="text-align: center">b</td></tr><tr><td style="text-align: center">xy</td><td style="text-align: center">yz</td></tr></table><p><strong>table headings</strong></p><table><tr><th>heading1</th><th>heading2</th></tr><tr><td>value11</td><td>value12</td></tr><tr><td>value21</td><td>value22</td></tr></table>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/tables')).

	self assert:
		'<a id="preformatted"></a><h3>Preformatted</h3><p><strong>Preformatted</strong></p><pre>main() { exit(0); }</pre>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/preformatted')).

	self assert:
		'<a id="formatting"></a><h3>Formatting</h3><p><strong>Formatting</strong> <strong>bold</strong> ''italic'' <code>monospaced</code> <del>strikethrough</del> <sub>subscripted</sub> <sup>superscripted</sup> <ins>underlined</ins></p>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/formatting')).

	self assert:
		'<a id="verbatim"></a><h3>Verbatim</h3><p><a href="http://www.foobar.com">verbatim foobar.com link</a></p><hr/><p><foobar>invalid tag surrounds this text (verbatim)</foobar></p>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/verbatim')).

	self assert:
		'<a id="links"></a><h3>Links</h3><p><strong>Links</strong></p><ul><li><a title="Links" class="internal">Root</a></li><li><a title="/nonexisting" class="broken">Non-existing internal page link</a></li><li><a title="http://www.foobar.com" class="external" href="http://www.foobar.com">http://www.foobar.com</a></li><li><a title="http://www.foobar.com" class="external" href="http://www.foobar.com">Aliased external link</a></li></ul>'
		equals: (self contentsOfStructure: (root lookupPath: 'book/part/chapter/links')).

	"Note: these values are not converted correctly in this test, probably due to the mock constext, so this test snippit is somewhat bogus"
	self assert:
		'<a id="values"></a><h3>Values</h3><p><strong>Values</strong></p><ul><li>date: date</li><li>time: time</li><li>owner: owner</li><li>group: group</li><li>source: source</li><li>user: user</li><li>kernel: kernel</li></ul>'
		equals:  (self contentsOfStructure: (root lookupPath: 'book/part/chapter/values')).
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/26/2012 01:19'!
testSubsubsubsections
	| root book epubview zip response content section |

	root := self bookWithSubsubsubsections.
	book := root lookupPath: 'book'.
	epubview := BOEPUBView on: (PRContext new setStructure: book).
	response := BOEPUBMockResponse new.
	epubview respondUsing: response.
	zip := ZipArchive new.
	zip readFrom: response stream.

	self assert: (zip memberNamed: 'OEBPS/book.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/part-1.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/chapter-1.html') notNil.

	self assert: (self contentsOfStructure: (root lookupPath: 'book/part-1/chapter-1'))
		= '<p>ch1</p><a id="section-1-1"></a><h3>Section-1-1</h3><p>sec-1-1</p><p>subsec</p><p>subsubsec</p><p>subsubsubsec</p>'.
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/26/2012 13:29'!
testTableOfContents
	| root book epubview zip response |

	root := self bookForTableOfContentsTest.
	book := root lookupPath: 'book'.
	epubview := BOEPUBView on: (PRContext new setStructure: book).
	response := BOEPUBMockResponse new.
	epubview respondUsing: response.
	zip := ZipArchive new.
	zip readFrom: response stream.

	self verifyContentMetadata: epubview.

	self assert: (zip memberNamed: 'OEBPS/content.opf') notNil.
	self assert: (zip memberNamed: 'OEBPS/toc.ncx') notNil.

	self assert: (zip memberNamed: 'OEBPS/content.opf') contents withUnixLineEndings
		= '<?xml version="1.0" encoding="utf-8" standalone="no"?>
<package xmlns="http://www.idpf.org/2007/opf" version="2.0" unique-identifier="book">
  <metadata>
    <dc:identifier xmlns:dc="http://purl.org/dc/elements/1.1/" id="book">_idbook</dc:identifier>
    <dc:title xmlns:dc="http://purl.org/dc/elements/1.1/">Book</dc:title>
    <dc:creator xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:opf="http://www.idpf.org/2007/opf" opf:file-as="nil">nil</dc:creator>
    <dc:language xmlns:dc="http://purl.org/dc/elements/1.1/">en</dc:language>
  </metadata>
  <manifest>
    <item id="ncxtoc" href="toc.ncx" media-type="application/x-dtbncx+xml"/>
<item id="id3" href="part-1.html" media-type="application/xhtml+xml"/>
<item id="id4" href="chapter-1.html" media-type="application/xhtml+xml"/>
<item id="id7" href="chapter-2.html" media-type="application/xhtml+xml"/>
<item id="id10" href="part-2.html" media-type="application/xhtml+xml"/>
<item id="id11" href="chapter-3.html" media-type="application/xhtml+xml"/>
<item id="id14" href="chapter-4.html" media-type="application/xhtml+xml"/>
  </manifest>
  <spine toc="ncxtoc">
<itemref idref="id3"/>
<itemref idref="id4"/>
<itemref idref="id7"/>
<itemref idref="id10"/>
<itemref idref="id11"/>
<itemref idref="id14"/>
  </spine>
</package>' withUnixLineEndings.

	self assert: (zip memberNamed: 'OEBPS/toc.ncx') contents withUnixLineEndings
		= '<?xml version="1.0" encoding="utf-8" standalone="no"?>
<ncx xmlns="http://www.daisy.org/z3986/2005/ncx/" version="2005-1">
  <head>
    <meta name="dtb:uid" content="_idbook"/>
  </head>
  <docTitle>
    <text>Book</text>
  </docTitle>
  <navMap>
<navPoint id="id2" playOrder="2">
  <navLabel><text>Book</text></navLabel>
  <content src="book.html"/>
<navPoint id="id3" playOrder="3">
  <navLabel><text>Part-1</text></navLabel>
  <content src="part-1.html"/>
<navPoint id="id4" playOrder="4">
  <navLabel><text>Chapter-1</text></navLabel>
  <content src="chapter-1.html"/>
<navPoint id="id5" playOrder="5">
  <navLabel><text>Section-1-1</text></navLabel>
  <content src="chapter-1.html#section-1-1"/>
</navPoint>
<navPoint id="id6" playOrder="6">
  <navLabel><text>Section-1-2</text></navLabel>
  <content src="chapter-1.html#section-1-2"/>
</navPoint>
</navPoint>
<navPoint id="id7" playOrder="7">
  <navLabel><text>Chapter-2</text></navLabel>
  <content src="chapter-2.html"/>
<navPoint id="id8" playOrder="8">
  <navLabel><text>Section-2-1</text></navLabel>
  <content src="chapter-2.html#section-2-1"/>
</navPoint>
<navPoint id="id9" playOrder="9">
  <navLabel><text>Section-2-2</text></navLabel>
  <content src="chapter-2.html#section-2-2"/>
</navPoint>
</navPoint>
</navPoint>
<navPoint id="id10" playOrder="10">
  <navLabel><text>Part-2</text></navLabel>
  <content src="part-2.html"/>
<navPoint id="id11" playOrder="11">
  <navLabel><text>Chapter-3</text></navLabel>
  <content src="chapter-3.html"/>
<navPoint id="id12" playOrder="12">
  <navLabel><text>Section-3-1</text></navLabel>
  <content src="chapter-3.html#section-3-1"/>
</navPoint>
<navPoint id="id13" playOrder="13">
  <navLabel><text>Section-3-2</text></navLabel>
  <content src="chapter-3.html#section-3-2"/>
</navPoint>
</navPoint>
<navPoint id="id14" playOrder="14">
  <navLabel><text>Chapter-4</text></navLabel>
  <content src="chapter-4.html"/>
<navPoint id="id15" playOrder="15">
  <navLabel><text>Section-4-1</text></navLabel>
  <content src="chapter-4.html#section-4-1"/>
</navPoint>
<navPoint id="id16" playOrder="16">
  <navLabel><text>Section-4-2</text></navLabel>
  <content src="chapter-4.html#section-4-2"/>
</navPoint>
</navPoint>
</navPoint>
</navPoint>
  </navMap>
</ncx>' withUnixLineEndings.
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 8/1/2012 12:33'!
testZipMembers
	| root book epubview zip response |

	root := self bookForZipMemberTest.
	book := root lookupPath: 'book'.
	epubview := BOEPUBView on: (PRContext new setStructure: book).
	response := BOEPUBMockResponse new.
	epubview respondUsing: response.
	zip := ZipArchive new.
	zip readFrom: response stream.

	self assert: (zip memberNamed: 'OEBPS/book.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/part-1.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/chapter-1-1.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/section-1-1-1.html') isNil.
	self assert: (zip memberNamed: 'OEBPS/part-2.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/chapter-2-1.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/section-2-1-1.html') isNil.
	self assert: (zip memberNamed: 'OEBPS/section-2-1-2.html') isNil.
	self assert: (zip memberNamed: 'OEBPS/chapter-2-2.html') notNil.
	self assert: (zip memberNamed: 'OEBPS/section-2-2-1.html') isNil.
	self assert: (zip memberNamed: 'OEBPS/section-2-2-2.html') isNil.
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/26/2012 00:40'!
todo
	"
	- formatting: italic formatting does not translate
	- missing <hr/> when it's the last item on page
	- links: *Email>info@foobar.com* is not consistently converted
	"! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/27/2012 12:11'!
verifyContentMetadata: epubview
	| book part1 chapter1 chapter2 part2 chapter3 chapter4 section11 section12 section21 section22 |

	book := (epubview items at: 1).
	self verifyItem: book id: 2 href: 'book.html' navLabelText: 'Book' src: 'book.html' isInManifest: false isInSpine: false.

	part1 := (book items at: 1).
	self verifyItem: part1 id: 3 href: 'part-1.html' navLabelText: 'Part-1' src: 'part-1.html' isInManifest: true isInSpine: true.

	chapter1 := (part1 items at: 1).
	self verifyItem: chapter1 id: 4 href: 'chapter-1.html' navLabelText: 'Chapter-1' src: 'chapter-1.html' isInManifest: true isInSpine: true.
	self assert: (section11 := chapter1 items at: 1) items isEmpty.
	self verifyItem: section11 id: 5 href: 'section-1-1.html' navLabelText: 'Section-1-1' src: 'chapter-1.html#section-1-1' isInManifest: false isInSpine: false.
	self assert: (section12 := chapter1 items at: 2) items isEmpty.
	self verifyItem: section12 id: 6 href: 'section-1-2.html' navLabelText: 'Section-1-2' src: 'chapter-1.html#section-1-2' isInManifest: false isInSpine: false.

	chapter2 := (part1 items at: 2).
	self verifyItem: chapter2 id: 7 href: 'chapter-2.html' navLabelText: 'Chapter-2' src: 'chapter-2.html' isInManifest: true isInSpine: true.
	self assert: (section21 := chapter2 items at: 1) items isEmpty.
	self verifyItem: section21 id: 8 href: 'section-2-1.html' navLabelText: 'Section-2-1' src: 'chapter-2.html#section-2-1' isInManifest: false isInSpine: false.
	self assert: (section22 := chapter2 items at: 2) items isEmpty.
	self verifyItem: section22 id: 9 href: 'section-2-2.html' navLabelText: 'Section-2-2' src: 'chapter-2.html#section-2-2' isInManifest: false isInSpine: false.

	part2 := (book items at: 2).
	self verifyItem: part2 id: 10 href: 'part-2.html' navLabelText: 'Part-2' src: 'part-2.html' isInManifest: true isInSpine: true.
	chapter3 := (part2 items at: 1).
	self verifyItem: chapter3 id: 11 href: 'chapter-3.html' navLabelText: 'Chapter-3' src: 'chapter-3.html' isInManifest: true isInSpine: true.
	self verifyItem: (chapter3 items at: 1) id: 12 href: 'section-3-1.html' navLabelText: 'Section-3-1' src: 'chapter-3.html#section-3-1' isInManifest: false isInSpine: false.
	self verifyItem: (chapter3 items at: 2) id: 13 href: 'section-3-2.html' navLabelText: 'Section-3-2' src: 'chapter-3.html#section-3-2' isInManifest: false isInSpine: false.
	chapter4 := (part2 items at: 2).
	self verifyItem: chapter4 id: 14 href: 'chapter-4.html' navLabelText: 'Chapter-4' src: 'chapter-4.html' isInManifest: true isInSpine: true.
	self verifyItem: (chapter4 items at: 1) id: 15 href: 'section-4-1.html' navLabelText: 'Section-4-1' src: 'chapter-4.html#section-4-1' isInManifest: false isInSpine: false.
	self verifyItem: (chapter4 items at: 2) id: 16 href: 'section-4-2.html' navLabelText: 'Section-4-2' src: 'chapter-4.html#section-4-2' isInManifest: false isInSpine: false.
! !

!BOEPUBViewTest methodsFor: 'tests' stamp: 'YanniChiu 3/27/2012 00:15'!
verifyItem: item id: id href: href navLabelText: navLabelText src: src isInManifest: isInManifest isInSpine: isInSpine
	self assert: item id = id.
	self assert: item href = href.
	self assert: item mediaType = 'application/xhtml+xml'.
	self assert: item navLabelText = navLabelText.
	self assert: item src = src.
	self assert: item isInManifest = isInManifest.
	self assert: item isInSpine = isInSpine.
! !

Object subclass: #BOEPUBMockResponse
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Book'!

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
attachmentWithFileName: ignored
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
binary
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
cacheForever
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
contentType: ignored
	"Do nothing"! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
stream

	^ stream ifNil: [ stream := (RWBinaryOrTextStream on: String new) binary ]! !

!BOEPUBMockResponse methodsFor: 'accessing' stamp: 'YanniChiu 3/7/2012 11:04'!
stream: anObject

	stream := anObject! !
